
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

static long lit_reset (struct WM_wwork *, short);
static long lit_event (struct WM_wwork *, struct WM_litm *);

static long MMOVE (struct WM_wwork *, struct WM_litm *);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);

static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
#if 0
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
#endif
static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    4		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    2		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

#define winX     240
#define winY     40

static QD_TEXTI (END, "ESC");

static struct WM_info info[ninfo + 1] =
{
    {0, 10, 6, 0, 0, 0, 0, 0, 0, NULL},
    {-1}
};


static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {winX, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 7, 7,			/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {0, 10,			/* xsize, ysize         size */
     0, 2,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     info},			/* *pobj                pointer to object list */
    {22, 10, 2, 2, 0, 0, 0, 7, NULL},
    {22, 10, winX - 30, 2, 0, 0, 0, 7, NULL},
    {-1}			/* end of array */
};

extern struct WM_sprite wm_sprite_move;

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {22, 10, 2, 2, 0, 0, 2, K_MOVE, &wm_sprite_move, 0, &mmove},
    {22, 10, winX - 24, 2, 0, 0, 0, K_CANCEL, &END, 1, &aexit},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    winX, winY,			/* xsize, ysize         size */
    0, 14,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    0, 0, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    NULL, /* &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};

static struct WM_appl appl[nappl + 1] =
{
    &aw0, NULL
};


static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    winX, winY + 14,		/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    NO_WCLEAR,  		/* flag                 no clear */
    1, 7, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    1, appl			/* nappl  *pappl        appl winds */
};


extern jcall (void (*)(), char *, int, int, int,...);

static long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;
    return wm_ldraw (wwk, -1);
}

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    return PT__CAN;
}

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    wm_swdef (wwk, apw, (int) aw0.pstat);
    return 0;
}

static long mpid;

static long MMOVE (struct WM_wwork *wwk, struct WM_litm *li)
{
    short dx, dy;
    int opr;
#ifndef SUSJB    
    opr = mt_prior (mpid, 0);
#else
    opr = mt_susjb (mpid, -1, NULL);
#endif
    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    ADRAW (wwk, &aw0);
#ifndef SUSJB
    mt_prior (mpid, opr);
#else
    mt_reljb (mpid);
#endif
    return lit_reset (wwk, li->item);
}

void PTRWindow (short *done)
{
    while (1)
    {
	wm_rptr (&ww);
	if(ws.evnt & PT_CAN)
	{
            *done = 1;
	}
    }
}

int InitWindow (struct QD_text *pq, short *done)
{
    int stdchn = -1;
    short len, xlen = 0;
    char *p;
    
    ww.chid = io_open ("con", 0);
    if (wm_findv (ww.chid))
    {
	if ((stdchn = io_open ("con", 0)) > 0)
	{
            short jno,ox,oy;
	    if (p = strchr ((char *) pq->chrs, ' '))
	    {
                xlen = pq->len;
                pq->len = (p - pq->chrs);
                len = 6 * pq->len;
	    }
	    else
	    {
		len = pq->len * 6;
	    }
            len += 6;
            
	    infw[1].xsize = len;
	    infw[1].xorg = (winX - len) / 2 - 3;
	    info[0].xsize = len;
	    info[0].pobj = malloc(pq->len+2);
            memcpy(info[0].pobj, pq, pq->len+2);
	    mpid = _Jobid;
	    aw0.pstat = (char *) stdchn;
	    sd_setin (stdchn, -1, 7);
	    ws.wwork = &ww;	/* set cross reference */
            jno = (mpid >> 1) % 6;
            ox = 256 * (jno & 1);
            oy = 20 + (jno / 2 ) * 60;
	    wm_prpos (&ww, ox, oy);
	    wm_wdraw (&ww);
	    jcall (PTRWindow, "CS-Ptr", 1, 1024, 1, done);
            if(xlen)
            {
                pq->len = xlen;
            }
	}
    }
    return stdchn;
}

void Update (int stdchn, char *txt, short len)
{
    if (io_sstrg (stdchn, 0, txt, len) > 0)
    {
	io_sbyte (stdchn, 0, '\n');
    }
}
#ifdef TEST
long _stack = 2048;

main(int ac, char **av)
{
    static QD_TEXTI (sp, "Opaque Window");
    static int stdchn;
    short done = 0;
    time_t t;
    QD_TEXT(26) qtim;
    
    if ((stdchn = InitWindow ((struct QD_text *) &sp, &done)) > 0)
    {
        while(!done)
        {
            mt_susjb(-1, 50, NULL);
            t = mt_rclck();
            cn_date((char *) &qtim, t);
            Update (stdchn, (char *) qtim.chrs, qtim.len);
        }
    }
}
int (*_Cstart) (int, char **) = main;
#endif
